/************************************************
 *	FICHERO:	Gyro_ITG3200.h
 *
 *	AUTORES:	-Guillermo Maroto
 *
 *    ---------------+---------------                                                
 *              ___ /^^[___              _                                           
 *             /|^+----+   |#___________//                             
 *           ( -+ |____|    ______-----+/                                            
 *            ==_________--'            \                                            
 *               ~_|___|__             
 *
 *********************************************/
#pragma once

#include "Gyro.h"
#include "I2C.h"
#include "MathFilter.h"
#include "MarotoCopter.h"

class Gyro_ITG3200 : public Gyro 
{
	
private:
	int gyroAddress;
	//float gyroLastData;
	
public:
	
	Gyro_ITG3200() : Gyro()
	{
		gyroAddress = 0x69;
		gyroFullScaleOutput = 2000.0;   // ITG3200 full scale output = +/- 2000 deg/sec
		gyroScaleFactor = radians(1.0 / 14.375);  //  ITG3200 14.375 LSBs per °/sec
		
		previousGyroTime = micros();
	}
	
	void initialize(void);
	
	void measure(void);
	
	void calibrate(void);
	
	const int getFlightData(byte axis);
	
	void autoZero();
	

};