/***********************************************
 *	FILE:	PID.h
 *
 *	AUTHORS:	-Guillermo Maroto
 *
 *  Modified from http://www.arduino.cc/playground/Main/BarebonesPIDForEspresso
 *  
 *   --------+--------         --------+--------
 *          | |_______________________| | 
 *                   |         |
 *                   |_________|
 *                 ~____|___|____    
 **********************************************/
#pragma once

#include "MarotoCopter.h"
#include "WProgram.h"

class PID {

private:
	float lastPosition;
	float integratedError;
	float windupGuard;	//Limites para que no sature
	float targetPosition;
	double pgain,igain,dgain;

	float currentPosition;
	double Output;
	
	double previousPIDTime;
	double currentTime;
public:

	PID()
	{	
		windupGuard = 1000.0;
	}
	
	void updatePID(float currentPos);

	void zeroIntegralError() 
	{
		integratedError = 0;
		previousPIDTime = currentTime;
	}
	
	float getP() {
	// get the P gain 
	return pgain;
	}
	float getI() {
	// get the I gain
	return igain;
	}
	float getD() {
	// get the D gain
	return dgain;
	}
	float getTargetPosition(){
		return targetPosition;
	}
	float getOutput(){
	return Output;
	}
	float getCurrentPosition(){
		return currentPosition;
	}
	
	void setP(float p) {
	pgain = p; 
	}

	void setI(float i) {
	igain = i; 
	}

	void setD(float d) {
	dgain = d; 
	}
	
	void setTargetPosition(float t){
		targetPosition=t;
	}
	
	void setWindUpGuard(float w){
		windupGuard=w;
	}
	
};